/* jshint -W117 */
Strophe.addConnectionPlugin('rayo',
    {
        RAYO_XMLNS: 'urn:xmpp:rayo:1',
        connection: null,
        call_resource: null,
        peer2resource: [],
        init: function (conn)
        {
            this.connection = conn;
            if (this.connection.disco)
            {
                this.connection.disco.addFeature('urn:xmpp:rayo:client:1');
            }

            this.connection.addHandler(
                this.onRayo.bind(this), this.RAYO_XMLNS, 'iq', 'set', null, null);

            //this.connection.addHandler(this.onPresence.bind(this), null,
              //  'presence', null, null, null, {matchBare: true});
        },
        onRayo: function (iq)
        {
            console.info("Rayo IQ", iq);
        },
        onPresence: function (pres)
        {
            var from = $(pres).attr('from');
            var sipGateway
                = $(pres).find('>sipgateway[xmlns="http://jitsi.org/sipgateway"]');
            var callResource = sipGateway.attr('resource');
            var state = sipGateway.attr('state');
            var error = $(sipGateway).find('>error');
            console.info("Resource from presence " + callResource +
                " state: " + state + " error? " + error.length, pres);

            if (callResource)
            {
                this.call_resource = callResource;
                this.peer2resource[from] = callResource;
            }
        },
        onPresenceUnavailable: function (pres)
        {
            var from = $(pres).attr('from');
            console.info("Presence unavailable from " + from, pres);
            console.info(
                "Peer2Res: " + this.peer2resource[from] +
                    " call res: " + this.call_resource);

            if (this.peer2resource[from] === this.call_resource)
            {
                console.info("SIP peer left");
                this.call_resource = null;
                this.peer2resource = [];
            }
        },
        dial: function (to, from, roomName)
        {
            if (this.call_resource)
            {
                console.warn("Call " + this.call_resource + " in progress");
                //return;
            }

            var self = this;
            var req = $iq(
                {
                    type: 'set',
                    to: config.hosts.call_control
                }
            );
            req.c('dial',
                {
                    xmlns: this.RAYO_XMLNS,
                    to: to,
                    from: from
                });
            req.c('header',
                {
                    name: 'JvbRoomName',
                    value: roomName
                });

            this.connection.sendIQ(
                req,
                function (result)
                {
                    console.info('Dial result ', result);

                    var resource = $(result).find('ref').attr('uri');
                    self.call_resource = resource.substr('xmpp:'.length);

                    console.info("Received resource: " + self.call_resource);
                },
                function (error)
                {
                    console.info('Dial error ', error);
                }
            );
        },
        hang_up: function ()
        {
            if (!this.call_resource)
            {
                console.warn("No call in progress");
                return;
            }

            var self = this;

            var req = $iq(
                {
                    type: 'set',
                    to: this.call_resource
                }
            );
            req.c('hangup',
                {
                    xmlns: this.RAYO_XMLNS
                });

            this.connection.sendIQ(
                req,
                function (result)
                {
                    console.info('Hangup result ', result);

                    self.call_resource = null;


                },
                function (error)
                {
                    console.info('Hangup error ', error);

                    self.call_resource = null;
                }
            );
        }/*,
        onPresence: function (pres)
        {
            console.info("RAYO presence", pres);
        }*/
    }
);